@echo off
setlocal EnableDelayedExpansion

rem "Aacini's Colors Tree.bat": Create a safe 216-color palette the shape of a Tree
rem Original design by Antonio Perez Ayala aka Aacini

rem Define the base digits
set base=-1
for %%a in (0 3 6 9 C F) do (
   set /A base+=1
   set digit[!base!]=%%a%%a
)
set /A baseM1=base-1

rem Generate the tree
set /A trunkHeight=1, useWhite=-1
set "nbspX4=[nbsp]|[nbsp]|[nbsp]|[nbsp]"
(
echo =
echo [table align="center" cellpadding="3"]
for /L %%a in (%base%,-1,0) do set /A A=%%a-1 & for /F %%A in ("!A!") do (

   rem Insert color names before branches # 1: Yellow White Aqua
   if !trunkHeight! equ 1 (
      set /P "=[bgcolor="#FFFF00"]Yellow|%nbspX4%|[bgcolor="#FFFFFF" align="center"]White|%nbspX4%|[bgcolor="#00FFFF" align="right"]Aqua"
      echo/
   )

   rem Insert color name before branches # 6: Lime
   if !trunkHeight! equ 6 (
      set /P "=[nbsp]|%nbspX4%|[bgcolor="#00FF00" align="center"]Lime"
      echo/
   )

   rem Insert branches
   set "color=black"
   for /L %%b in (%base%,-1,0) do (
      if %%b equ !useWhite! set "color=white"
      set "line="
      rem Left margin
      for /L %%i in (%%a,1,%baseM1%) do set "line=!line![nbsp]|"
      rem Left branch
      for /L %%c in (0,1,%%a) do (
         set "value=!digit[%%a]!!digit[%%b]!!digit[%%c]!"
         set "line=!line![bgcolor="#!value!"][color="!color!"]!value![/color]|"
      )
      rem Right branch
      for /L %%c in (%%A,-1,0) do (
         set "value=!digit[%%c]!!digit[%%b]!!digit[%%a]!"
         set "line=!line!|[bgcolor="#!value!"][color="!color!"]!value![/color]"
      )
      echo !line!
   )

   rem Insert color names after branches # 1: Red Fuchsia Blue
   if !trunkHeight! equ 1 (
      set /P "=[bgcolor="#FF0000"]Red|%nbspX4%|[bgcolor="#FF00FF" align="center"]Fuchsia|%nbspX4%|[bgcolor="#0000FF" align="right"]Blue"
      echo/
   )

   rem Insert color name after branches # 6: black
   if !trunkHeight! equ 6 (
      set /P "=[nbsp]|%nbspX4%|[bgcolor="#000000" align="center"][color="white"]Black[/color]"
      echo/
   )

   set /A trunkHeight+=1, useWhite+=1

)
    
echo [/table]

echo [color="#999999" size="-1"]Original design by Antonio Prez Ayala (aka Aacini^)[/color]
echo [hr]
echo [code:"Aacini's Colors Tree.bat" height:26em;]Aacini's Colors Tree.bat
set /P "=["
echo /code]
) > "Aacini's Colors Tree.txt" < NUL

TextToHtml "Aacini's Colors Tree.txt" /N
