@echo off

rem DirTreeInHtml.bat: Create a web page with the contents of a folder
rem Antonio Perez Ayala

if "%~1" neq "/?" goto begin
echo Create a web page with the contents of the given folder
echo/
echo DirTreeInHtml.bat [dir] [.type.list]
echo/
echo    dir          Name of the folder to process.
echo                 If not given, current directory is processed.
echo/
echo    .type.list   List of extensions of the files that will be listed
echo                 in the web page; the default is: .txt.bat.html
echo                 Files of other types are just summarized.
echo/
echo The web page is created in the given folder with the same name
echo of the folder plus " Directory Tree.html"
echo/
echo The files in the given folder will not appear in the page; only subfolders.
echo/
echo This program requires TextToHtml.bat conversion program.
goto :EOF

:begin
setlocal
set "fileTypes=%~1"
if defined fileTypes (
   if "%fileTypes:~0,1%" neq "." (
      cd %1
      set "fileTypes=%~2"
   ) else if "%fileTypes:~0,2%" equ ".." (
      cd %1
      set "fileTypes=%~2"
   )
)
set "fullName=%cd%"
for %%d in ("%fullName%") do set "name=%%~Nd"
if not defined fileTypes set "fileTypes=.txt.bat.html"
echo Creating tree of "%cd%"
echo/
(
echo =Contents of %fullName%=
call :ProcessTree "." 1 "."
echo =
) > "%name% directory tree.txt"
echo/
echo/
TextToHtml.bat "%name% directory tree.txt"
echo ERROR: TextToHtml.bat conversion program not found
goto :EOF


:ProcessTree folder level previousPath
setlocal EnableDelayedExpansion
cd "%~1"
set /A level=%2+1
set "div="
for /L %%i in (1,1,%level%) do set "div=!div!="
for %%a in ("%cd%") do echo %div:~2%%%~Na > CON
for /D %%a in (*) do (
   echo !div!%%a!div!
   set /P "=Files in folder: [url=%%~Fa]%~3/%%a[/url]" < NUL
   for /F "delims==" %%b in ('set . 2^>NUL') do set "%%b="
   set /A lines=0, noExt=0
   cd "%%a"
   for %%b in (*.*) do (
      if "%%~Xb" neq "" (
         set /A "%%~Xb+=1"
         set "file[!%%~Xb!][%%~Xb]=%%~Fb"
         if !%%~Xb! gtr !lines! if "!fileTypes:%%~Xb=!" neq "%fileTypes%" set lines=!%%~Xb!
      ) else (
         set /A noExt+=1
      )
   )
   cd ..
   if !lines! equ 0 (
      echo  (no files^)
   ) else (
      echo/
      echo [table border="1" rules="cols" cellpadding="5" bgcolor="Silver"]
      set "header="
      for %%b in (%fileTypes:.= %) do (
         set "header=!header!|[u]Type: %%b[/u]"
         set /A "b=.%%b+1"
         for /L %%i in (!b!,1,!lines!) do set "file[%%i][.%%b]="
      )
      echo !header!
      for /L %%i in (1,1,!lines!) do (
         set "line="
         for %%b in (%fileTypes:.= %) do for %%c in ("!file[%%i][.%%b]!") do (
            if "%%~c" neq ""  (
               set "line=!line!|[url=%%~c]%%~Nc[/url]
            ) else (
               set "line=!line!|[nbsp]"
            )
         )
         echo !line:~1!
      )
      echo [/table]
      for %%b in (%fileTypes:.= %) do set ".%%b="
      set "footer="
      for /F "tokens=1,2 delims==" %%b in ('set . 2^>NUL') do (
         set "footer=!footer!%%c of type %%b, "
      )
      if !noExt! gtr 0 (
         if defined footer set "footer=!footer:~0,-2! and "
         set "footer=!footer!!noExt! file(s) with no type, "
      )
      if defined footer echo Unlisted files: !footer:~0,-2!
   )
   call :ProcessTree "%%a" %level% "%~3/%%a"
)
cd ..
exit /B
