@echo off
setlocal EnableDelayedExpansion

rem FCompInHtml.bat: Format FC command output in a pleasant way
rem Antonio Perez Ayala
rem - Nov/10/2012: First version
rem - Nov/25/2013: Generate output for TextToHtml.bat conversion program

if "%~2" neq "" goto begin
echo Format FC output identifying added, deleted or modified sections
echo/
echo FCompInHtml  same parameters and switches of FC command
goto :EOF

:begin

set while=if not
set   and=if not
set do=goto endwhile
set endwhile=goto while
set break=goto endwhile

set params=%*
set "cutNumber="
if "!params:/N=!" neq "!params!" set "cutNumber=:~8"
echo Comparing files
fc %* > diffs.txt
if %errorlevel% equ 0 (
   echo FCompInHtml: no differences encountered
   del diffs.txt
) else (
   echo Analyzing differences...
   call :FormatFCOutput < diffs.txt > "Comparison Differences.txt"
   del diffs.txt
   "%~DP0TextToHtml" "Comparison Differences.txt"
)
goto :EOF


:FormatFCOutput

set "slash=/"
echo =
set /P line=
echo [color="0" size="+2"]!line![/color]
echo [hr]
set /P line=
:while  There is another set of differences
%while% defined line %do%

   set "line="
   set /P line=
   if defined line (
      set "line=!line:[=&#91;!"
      set "line=!line:|=&#124;!"
   )
   set old=0
   :while1  There is another line in this old section
   %while% "!line:~0,5!" neq "*****" %do%1

      set /A old+=1
      set "oldLine[%old%]=!line!"
      :while1.5  PATCH FOR FC GLITCH: Concatenate next line while current is 127 chars. long
      %while% defined line           %do%1.5
        %and% "!line:~126,1!" neq "" %do%1.5
         set "line="
         set /P line=
         rem                          or until this set of differences ends
         if "!line:~0,5!" equ "*****" %break%1
         if defined line (
            set "line=!line:[=&#91;!"
            set "line=!line:|=&#124;!"
            set "oldLine[%old%]=!oldLine[%old%]!!line%cutNumber%!"
         )
      %endwhile%1.5
      :endwhile1.5
      set "oldLine[%old%]=!oldLine[%old%]! "
      set "line="
      set /P line=
      if defined line (
         set "line=!line:[=&#91;!"
         set "line=!line:|=&#124;!"
      )
   %endwhile%1
   :endwhile1

   set "line="
   set /P line=
   if defined line (
      set "line=!line:[=&#91;!"
      set "line=!line:|=&#124;!"
   )
   set new=0
   :while2  There is another line in this new section
   %while% "!line:~0,5!" neq "*****" %do%2

      set /A new+=1
      set "newLine[%new%]=!line!"
      :while2.5  PATCH FOR FC GLITCH: Concatenate next line while current is 127 chars. long
      %while% defined line           %do%2.5
        %and% "!line:~126,1!" neq "" %do%2.5
         set "line="
         set /P line=
         rem                          or until this set of differences ends
         if "!line:~0,5!" equ "*****" %break%2
         if defined line (
            set "line=!line:[=&#91;!"
            set "line=!line:|=&#124;!"
            set "newLine[%new%]=!newLine[%new%]!!line%cutNumber%!"
         )
      %endwhile%2.5
      :endwhile2.5
      set "newLine[%new%]=!newLine[%new%]! "
      set "line="
      set /P line=
      if defined line (
         set "line=!line:[=&#91;!"
         set "line=!line:|=&#124;!"
      )
   %endwhile%2
   :endwhile2

   rem Identify the type of this set

   rem PATCH FOR FC GLITCH: If both versions are size 2, it is a modified section
   set /A "oldEqu2_And_NewNeq2=^!(old-2)*(new-2), newEqu2_And_OldNeq2=^!(new-2)*(old-2)"
   if %old% equ 0 (      
      echo [b]NEW SECTION ADDED AT END OF FILE[/b]
      echo [table border="0" cellspacing="0" bgcolor="Black" width="100%%"]
      for /L %%i in (1,1,!new!) do echo [color="Lime" face="Courier New, Monaco, monospace"]!newLine[%%i]![/color]
      echo [/table]
   ) else if %new% equ 0 (
      echo [b]OLD SECTION DELETED FROM END OF FILE[/b]
      echo [table border="0" cellspacing="0" bgcolor="Black" width="100%%"]
      for /L %%i in (1,1,!old!) do echo [color="Red" face="Courier New, Monaco, monospace"]!oldLine[%%i]![/color]
      echo [/table]
   ) else if %oldEqu2_And_NewNeq2% neq 0 (
      call :getBothLines[1]
      if "!oldLine!" equ "!newLine!" (
         echo [b]NEW SECTION ADDED[/b]
         echo [table border="0" cellspacing="0" bgcolor="Black" width="100%%"]
         echo [color="White" face="Courier New, Monaco, monospace"]!oldLine[1]![/color]
         set /A new-=1
         for /L %%i in (2,1,!new!) do echo [color="Lime" face="Courier New, Monaco, monospace"]!newLine[%%i]![/color]
         echo [color="White" face="Courier New, Monaco, monospace"]!oldLine[2]![/color]
         echo [/table]
      ) else (
         echo [b]NEW SECTION ADDED AT BEGINNING OF FILE[/b]
         echo [table border="0" cellspacing="0" bgcolor="Black" width="100%%"]
         set /A new-=2
         for /L %%i in (1,1,!new!) do echo [color="Lime" face="Courier New, Monaco, monospace"]!newLine[%%i]![/color]
         echo [/table]
      )
   ) else if %newEqu2_And_OldNeq2% neq 0 (
      call :getBothLines[1]
      if "!oldLine!" equ "!newLine!" (
         echo [b]OLD SECTION DELETED[/b]
         echo [table border="0" cellspacing="0" bgcolor="Black" width="100%%"]
         echo [color="White" face="Courier New, Monaco, monospace"]!newLine[1]![/color]
         set /A old-=1
         for /L %%i in (2,1,!old!) do echo [color="Red" face="Courier New, Monaco, monospace"]!oldLine[%%i]![/color]
         echo [color="White" face="Courier New, Monaco, monospace"]!newLine[2]![/color]
         echo [/table]
      ) else (
         echo [b]OLD SECTION DELETED FROM BEGINNING OF FILE[/b]
         echo [table border="0" cellspacing="0" bgcolor="Black" width="100%%"]
         set /A old-=2
         for /L %%i in (1,1,!old!) do echo [color="Red" face="Courier New, Monaco, monospace"]!oldLine[%%i]![/color]
         echo [/table]
      )
   ) else (
      if %new% gtr %old% (set height=%new%) else set height=%old%
      if !height! leq 4 (set /A height+=2) else set /A height=height*12/10+1
      if !height! gtr 32 set height=32
      echo [b]SECTION MODIFIED[/b]
      echo [code color:White; background:Black; font-size:1em; font-weight:normal; height:!height!em; width:48%%; float:left;]
      for /L %%i in (1,1,%old%) do echo(!oldLine[%%i]!
      echo [%slash%code]
      echo [code color:White; background:Black; font-size:1em; font-weight:normal; height:!height!em; width:48%%; float:right;]
      for /L %%i in (1,1,%new%) do echo(!newLine[%%i]!
      echo [%slash%code]
      echo [br clear="all"]
   )

   rem Pass to next set of differences
   set /P line=
   set "line="
   set /P line=
%endwhile%
:endwhile

echo [url=#][style="float:right; font-size:small;"]Top[/style][/url][br]

exit /B


:getBothLines[1]
set "oldLine=!oldLine[1]%cutNumber%!"
set "newLine=!newLine[1]%cutNumber%!"
exit /B
